<?php
function ShowDeletedMsgs(){
  if ($GLOBALS['islogged']){ //если юзер залогинен берём его данные и настройки отображения контента

    $stmt = mysqli_prepare($GLOBALS['DB'], "SELECT timezone, timeformat, mpp, name, avatar FROM users WHERE iduser=? LIMIT 1");
    mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser'])); 
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $timezone, $timeformat, $mpp, $username, $avatar);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);

    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT id_msg FROM posts WHERE deleted=1 AND id_author=?'); //подсчитываем сколько всего удалённых сообщений
    mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser'])); 
    mysqli_stmt_execute($stmt);
    mysqli_stmt_store_result($stmt);
    $TotalMessages = mysqli_stmt_num_rows($stmt);
    mysqli_stmt_close($stmt);

    if ($TotalMessages > 0){
      $page = $_GET['page'];
      if ($page <= 0) $page = 1;   
      $TotalPages = ceil($TotalMessages / $mpp); //максимальный номер страницы = кол-во страниц
      if ($page > $TotalPages) $page = $TotalPages;
      if ($page == $TotalPages){ //если страница единственная или последняя - вычисляем длину списка сообщений
        $ShowMessages = $TotalMessages - (($TotalPages - 1) * $mpp);
      }else{ // если страница внутри итератора - длина списка равна настроечной
        $ShowMessages = $mpp;
      }
      $Offset = $mpp * ($page - 1);

      if ($TotalPages > 1){ //создаём итератор, только если страниц 2 и более
        require 'PageIteratorCreate.php';
        $PageIterator = PageIteratorCreate(25, $TotalPages, $page, './?ai=13&page='); //создаём html-код итератора страниц (ячейки таблицы) 
      }else $PageIterator = '';

      $html = '<table width="100%" style="background-color: #f5f5f5; font-size: 16px; font-weight: 600"><tr><td height="2px"></td></tr>
      <tr><td><div align="center">Ваши удалённые сообщения ('.$TotalMessages.')</div></td></tr><tr><td></td></tr></table>'; //заголовок страницы

      $html .= '<table cellspacing="0" cellpadding="0"><tr>'.$PageIterator.'</tr><tr><td height="2px"></td></tr></table>'; //верхний итератор

      $html .= '<table width="100%" cellspacing="0" cellpadding="0"><tr style="background-color: #98c6d2"><td colspan="2" height="1px"></td></tr>'; //начало таблицы сообщений

      //шаблон строки таблицы
      $template = 
      '<tr style="background-color: #f5f5f5"><td width="15%" valign="top" align="center">
        <div style="min-height: 21px; display: table"><p style="display: table-cell; vertical-align: bottom">
        <span style="font-size: 15px; font-weight: 600">{name}</span></p></div>
        <div style="margin-top: 5px">{avatar}</div>
      </td>
      <td width="85%">
        <div><table width="100%" height="21px" cellspacing="0" cellpadding="0"><tr style="background: #e5e5e5">
        <td width="100%" align="left"><span title="Автор топика: {topic_creator}" style="padding-left:6px;font-size:12px;color:#585858">{topic_name}</span></td></tr></table></div>
        <div><table width="100%" height="21px" cellspacing="0" cellpadding="0"><tr style="background: #e5e5e5">
        <td width="17%" align="middle"><span title="Время создания" style="font-size:12px;color:#585858">{createtime}</span></td>
        <td width="1%"></td>
        <td width="17%"><span title="Время правки" style="font-size: 12px;color:#585858">{edittime}</span></td>
        <td width="45%"></td>
        <td width="20%" align="right"><span style="font-size: 14px">№{id_msg}</span></td>
        </tr></table></div>
        <div class="message">{message}</div>
        <div><table width="100%" height="26px" cellspacing="0" cellpadding="0"><tr><td align="right">{niz}</td></tr></table></div>
      </td></tr>
      <tr style="background-color: #98c6d2"><td colspan="2" height="1px"></td></tr>';

      $stmt = mysqli_prepare($GLOBALS['DB'],
      'SELECT posts.id_msg, posts.createtime, posts.edittime, posts.text, posts.likes, posts.disagrees, topics.name, users.name
       FROM posts
       LEFT JOIN topics ON posts.id_topic = topics.id_topic
       LEFT JOIN users ON topics.id_author = users.iduser
       WHERE posts.deleted=1 AND posts.id_author = ? 
       ORDER BY posts.id_msg DESC
       LIMIT '."$ShowMessages".' OFFSET '."$Offset"); //берём все удалённые сообщения, сортируя от свежих к старым
      mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser']));
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $id_msg, $createtime, $edittime, $text, $likes, $disagrees, $topicname, $topicauth);

      require 'TagFormat.php';
      while (mysqli_stmt_fetch($stmt)){
        $row = $template; //копируем шаблон строки

        if (!empty($avatar)) //если аватар есть - выводим его
        $row = str_replace('{avatar}','<img src="./avatars/'.$avatar.'.jpg" alt="Аватар" title="Перейти на страницу участника">', $row); 
        else $row = str_replace('{avatar}','', $row);

        $row = str_replace('{id_msg}',$id_msg, $row);
        $row = str_replace('{name}',$username, $row);
        $row = str_replace('{topic_name}', $topicname, $row); 
        $row = str_replace('{topic_creator}', $topicauth, $row);
        $row = str_replace('{message}', TagFormat($text), $row); //выводим сообщение со всеми тегами

        $date = date_create($createtime); //для отображения смещаем время на указанное в настройках количество часов
        if ($timezone < 0){
          $timeshift = abs($timezone);
          date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
        }else{
          date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
        }
        $createtime = date_format($date, $timeformat);
        $row = str_replace('{createtime}',$createtime, $row);

        if ($edittime != '0000-00-00 00:00:00'){
          $date = date_create($edittime); //для отображения смещаем время на указанное в настройках количество часов
          if ($timezone < 0){
            $timeshift = abs($timezone);
            date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
          }else{
            date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
          }
          $edittime = date_format($date, $timeformat);
          $row = str_replace('{edittime}',$edittime, $row);
        }else{
          $row = str_replace('{edittime}','', $row);
        }

        $niz = '<div style="float:right"><a class="noneall" style="cursor: pointer">'.
        '<img title="Окончательно удалить сообщение" onclick="DelMsg('.$id_msg.')" src="./pics/delete.png" alt="Удалить"></a></div>';

        if ($likes>0) $pref1 = '+';
        else $pref1 = '';
        if ($disagrees>0) $pref2 = '-';
        else $pref2 = '';
        $niz .='<div style="float:right;margin-top:5px;padding-left:5px;padding-right:5px;"><span style="color:blue">'.$pref1.$likes.
        '</span> | <span style="color:red">'.$pref2.$disagrees.'</span></div>';

        $row = str_replace('{niz}', $niz, $row);

        $html .= $row;
      }
      mysqli_stmt_close($stmt);

      $html .= '</table><script>
      function DelMsg(idmsg){if(confirm("Вы уверены, что хотите безвозвратно удалить данное сообщение?")){var data="ai=12&id="+encodeURIComponent(idmsg);AsyncAct(data);}}
      </script>
      <table cellspacing="0" cellpadding="0"><tr><td height="3px"></td></tr><tr>'.$PageIterator.'</tr><tr><td height="2px"></td></tr></table>';//нижний итератор

    }else{ //если удалённых сообщений нет
      $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
      <tr><td><div align="center">У Вас нет удалённых сообщений.</div></td></tr><tr><td height="10px"></td></tr></table>';  
      return $html; 
    }
  }else{ //если юзер не залогинен
    $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
    <tr><td><div align="center">Авторизуйтесь, чтобы просматривать удалённые сообщения.</div></td></tr><tr><td height="10px"></td></tr></table>';  
    return $html; //не используем сообщения ai=200 чтобы после авторизации вернуться на ту же страницу
  }
  return $html;
}
?>