<?php
require 'const.php';

if (!isset($_COOKIE['iduser']) or !isset($_COOKIE['hash'])){ //если юзер не авторизован то перенаправляем на начальную страницу
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName);
  else header('Location: http://'.$HostName);
  exit();
}

$DB = mysqli_connect($DBhost, $DBuser, $DBpwd);
if ($DB !== false){
  mysqli_select_db($DB, $DBname); 

  $stmt = mysqli_prepare($DB, "SELECT user_hash FROM users WHERE iduser=? LIMIT 1");
  mysqli_stmt_bind_param($stmt, "i", intval($_COOKIE['iduser']));
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $user_hash);
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if ($user_hash !== $_COOKIE['hash']){ //если хэши не совпадают
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName); // перенаправляем на начальную страницу
      else header('Location: http://'.$HostName);
      exit();
  }else{//если хэши совпадают - пользователь опознан
    if (empty($_GET['id'])){ //если id передан через POST
      $num = preg_match_all("/chb[0-9]+/", print_r($_POST, true), $matches, PREG_PATTERN_ORDER);
    }else{ //если id передан через параметры
      $num = 1;
      $matches[0][0] = $_GET['id'];
    }

    if ($_GET['mode'] == 0){ //если удаляем входящие сообщения
      for ($i = 0; $i <= ($num-1); $i++){
        $pm = str_replace('chb', '', $matches[0][$i]);

        $stmt = mysqli_prepare($DB, 'SELECT id_to, isdelete_from FROM pm WHERE id_pm=? LIMIT 1');
        mysqli_stmt_bind_param($stmt, 's', $pm); // проверяем удалил ли отправитель сообщение у себя
        mysqli_stmt_execute($stmt);
        mysqli_stmt_bind_result($stmt, $id_to, $isdelete_from);
        mysqli_stmt_fetch($stmt);
        mysqli_stmt_close($stmt);

        if ($id_to == $_COOKIE['iduser']){ //проверка на уровень доступа
          if ($isdelete_from == 1){ //если отправитель удалил у себя - удаляем полностью сообщение из базы
            $stmt = mysqli_prepare($DB, 'DELETE FROM pm WHERE id_pm=? LIMIT 1');
            mysqli_stmt_bind_param($stmt, 's', $pm);
            mysqli_stmt_execute($stmt);
            mysqli_stmt_close($stmt);
          }else{//если отправитель у себя не удалил - устанавливаем только индикатор удаления
            $stmt = mysqli_prepare($DB, 'UPDATE pm SET isdelete_to=1 WHERE id_pm=? LIMIT 1');
            mysqli_stmt_bind_param($stmt, 's', $pm);
            mysqli_stmt_execute($stmt);
            mysqli_stmt_close($stmt);
          }
        }
      }
    }

    if ($_GET['mode'] == 1){ //если удаляем исходящие сообщения
      for ($i = 0; $i <= ($num-1); $i++){
        $pm = str_replace('chb', '', $matches[0][$i]);

        $stmt = mysqli_prepare($DB, 'SELECT id_from, isdelete_to FROM pm WHERE id_pm=? LIMIT 1');
        mysqli_stmt_bind_param($stmt, 's', $pm); // проверяем удалил ли получатель сообщение у себя
        mysqli_stmt_execute($stmt);
        mysqli_stmt_bind_result($stmt, $id_from, $isdelete_to);
        mysqli_stmt_fetch($stmt);
        mysqli_stmt_close($stmt);

        if ($id_from == $_COOKIE['iduser']){ //проверка на уровень доступа
          if ($isdelete_to == 1){ //если получатель удалил у себя - удаляем полностью сообщение из базы
            $stmt = mysqli_prepare($DB, 'DELETE FROM pm WHERE id_pm=? LIMIT 1');
            mysqli_stmt_bind_param($stmt, 's', $pm);
            mysqli_stmt_execute($stmt);
            mysqli_stmt_close($stmt);
          }else{//если получатель у себя не удалил - устанавливаем только индикатор удаления
            $stmt = mysqli_prepare($DB, 'UPDATE pm SET isdelete_from=1 WHERE id_pm=? LIMIT 1');
            mysqli_stmt_bind_param($stmt, 's', $pm);
            mysqli_stmt_execute($stmt);
            mysqli_stmt_close($stmt);
          }
        }
      }
    }
  }
  mysqli_close($DB);
}
header('Location:'.$_SERVER['HTTP_REFERER']); //переходим на ту же страницу, где и были
?>