<?php
require 'const.php';
session_start();
$DB = mysqli_connect($DBhost, $DBuser, $DBpwd);
if ($DB == false) print('Ошибка соединения с базой данных: '.mysqli_connect_error());
else{
mysqli_select_db($DB, $DBname);

$html = file_get_contents('./templates/default.html');

if (isset($_COOKIE['iduser']) and isset($_COOKIE['hash'])){ //если куки авторизации есть
   $stmt = mysqli_prepare($DB, 'SELECT name, user_hash, status FROM users WHERE iduser=? LIMIT 1');
   mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser']));
   mysqli_stmt_execute($stmt);
   mysqli_stmt_bind_result($stmt, $name, $user_hash, $status);
   mysqli_stmt_fetch($stmt);
   mysqli_stmt_close($stmt);

   $islogged = false;
   if ($user_hash !== $_COOKIE['hash']){ //если хэши не совпадают
      setcookie('iduser', '', time()-10000,'/','',true,true); // удаляем куки
      setcookie('hash', '', time()-10000,'/','',true,true); 
      $menu = file_get_contents('./templates/login.html'); //выводим пустую форму для логина
      $menu = str_replace('{error}', '', $menu);
      $menu = str_replace('{newpass}', '', $menu);
      require 'PrepareGuestForm.php';
      $menu = PrepareGuestForm($menu); // устанавливаем параметры окна настроек гостевого доступа
   }else{//если хэши совпадают - пользователь опознан
     $menu = file_get_contents('./templates/logout.html'); //загружаем форму меню
     $menu = str_replace('{username}', $name, $menu);
     $_SESSION['username'] = $name;

     $timevisit = date('Y-m-d H:i:s'); //берём текущее серверное время
     $stmt = mysqli_prepare($DB, 'UPDATE users SET timevisit=? WHERE user_hash=?'); //обновляем время визита
     mysqli_stmt_bind_param($stmt, 'ss', $timevisit, $_COOKIE['hash']);
     mysqli_stmt_execute($stmt);
     mysqli_stmt_close($stmt);
     $islogged = true; //эта переменная подтверждает, что хэш и id участника - аутентичны
   }
}else{ //если куки нету
   $menu = file_get_contents('./templates/login.html'); //выводим форму логина
   if (isset($_SESSION['LoginError'])){ //если попытка логина была, но с ошибкой
      $error = '<tr><td colspan="5"></td><td colspan="3">
         <div style="font-size: 12px; height: 16px; color: red" align="left">'.$_SESSION['LoginError'].'</div></td></tr>';
      unset($_SESSION['LoginError']);
      $newpass='<tr height="19px"><td colspan="5"></td><td colspan="3"><div style="font-size: 12px" vertical-align="bottom" align="left">
         <a href="./?ai=100">Запросить смену пароля по электронной почте</a></div></td></tr>';
   }else{
      $error = '';
      $newpass = ''; 
   }
   $menu = str_replace('{error}', $error, $menu);
   $menu = str_replace('{newpass}', $newpass, $menu);
   require 'PrepareGuestForm.php';
   $menu = PrepareGuestForm($menu); // устанавливаем параметры окна настроек гостевого доступа
}

switch ($_GET['ai']){
   case 1:    // показ формы регистрации нового участника
      require 'AddNewUserForm.php';
      $content = AddNewUserForm();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Регистрация</title>', $html);
      break;
   case 2:    // попытка регистрации нового участника
      require 'TryAddNewUser.php';
      $content = TryAddNewUser();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Регистрация</title>', $html);
      break;
   case 3:    // попытка активации почты участника
      require 'ActivateUserEmail.php';
      $id = $_GET['id'];
      $code = $_GET['code'];
      if (!empty($id) and !empty($code)){
         $content = ActivateUserEmail($id, $code);
         $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Активация</title>', $html);
      }else{
         if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName);
         else header('Location: http://'.$HostName);
      exit();         
      }
      break;  
   case 4:    // настройки учётной записи участника
      require 'ShowUserAccountForm.php';
      $content = ShowUserAccountForm();
      if ($islogged) $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Настройки</title>', $html);
      break;  
   case 5:    //отправка письма активации из аккаунта
      require 'SendEmailActForm.php';
      $content = SendEmailActForm();
      if ($islogged) $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Активация</title>', $html);
      break;  
   case 6:    //показ формы для активаци по Telegram 
      if ($islogged){//если юзер авторизован
         $content = file_get_contents('./templates/SMSActivationForm.html');
         if (isset($_SESSION['SMSActFormError'])){ //если форма была заполнена но с ошибкой
            $error = $_SESSION['SMSActFormError'];
            unset($_SESSION['SMSActFormError']);   
         }else{$error = '';}
         $content = str_replace('{error}', $error, $content);
         $html = str_replace('<title>AGI.place</title>','<title>AGI.place - Активация</title>', $html);
      }else{ //если не авторизован - перенаправляем на титульную страницу
         if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName);
         else header('Location: http://'.$HostName);}
      break;
   case 7:   // попытка отправки SMS для активации
      if ($islogged){
         require 'TrySendTelegram.php';
         $content = TrySendTelegram();
         $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Активация</title>', $html);
      }   
      break;
   case 8:   // показ формы для создания нового топика
      require 'NewTopicForm.php';
      $content = NewTopicForm($status);
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Новый топик</title>', $html); 
      break;
   case 9:   // показ контента топика
      require 'ShowTopic.php';     
      $content = ShowTopic();
      if (isset($_SESSION['topictitle'])){
         $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - '.$_SESSION['topictitle'].'</title>', $html);
         unset($_SESSION['topictitle']);  
      }        
      break;
   case 10:  // форма для создания нового сообщения в топике
      require 'ShowNewMSGForm.php';
      $content = ShowNewMSGForm();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Создать сообщение</title>', $html); 
      break;
   case 11:  // форма для редактирования созданного сообщения в топике
      require 'ShowEditMSGForm.php';
      $content = ShowEditMSGForm();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Редактирование сообщения</title>', $html); 
      break;
   case 12:  // форма для редактирования топика (название, тип топика)
      require 'ShowEditTopicForm.php';
      $content = ShowEditTopicForm();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Редактирование топика</title>', $html); 
      break;
   case 13:  // показ списка удалённых сообщений
      require 'ShowDeletedMsgs.php';
      $content = ShowDeletedMsgs();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Удалённые сообщения</title>', $html); 
      break;
   case 14:  // показ формы анкеты
      require 'ShowQuestForm.php';
      $content = ShowQuestForm();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Анкета</title>', $html); 
      break;
   case 20:   // форма для отправки личного сообщения
      $id = $_GET['id'];
      require 'ShowPMForm.php';
      $content = ShowPMForm($id);
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Личное сообщение</title>', $html); 
      break;
   case 21:   // вывод исходящего личного сообщения
      if ($islogged){
         require 'ShowOutPM.php';
         $content = ShowOutPM();
         $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Личное сообщение</title>', $html); 
      }
      break;
   case 22:   // вывод списка полученных личных сообщений
      if ($islogged){
         require 'ShowIncomPMList.php';
         $content = ShowIncomPMList();
         $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Входящие личные сообщения</title>', $html); 
      }
      break;
   case 23:   // вывод входящего личного сообщения
      if ($islogged){
         require 'ShowPM.php';
         $content = ShowPM();
         $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Личное сообщение</title>', $html); 
      }
      break;
   case 24:   // вывод списка отправленных личных сообщений
      if ($islogged){
         require 'ShowOutPMList.php';
         $content = ShowOutPMList();
         $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Исходящие личные сообщения</title>', $html); 
      }
      break;
   case 25:   // форма для исходящего личного сообщения как ответа
      if ($islogged){
         $id = $_GET['id'];
         require 'ReplyPMForm.php';
         $content = ReplyPMForm($id);
         $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Личное сообщение</title>', $html); 
      }
      break;
   case 30:  // форма для расширенного поиска
      require 'ShowSearchForm.php';
      $content = ShowSearchForm();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Поиск</title>', $html);
      break;
   case 31: // быстрый поиск и результаты
      require 'Search.php';
      $content = Search();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Результат поиска</title>', $html); 
      break;
   case 32: // расширенный поиск и результаты
      require 'ExtSearch.php';
      $content = ExtSearch();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Результат поиска</title>', $html); 
      break;   
   case 40:  // отображение списка жалоб
      require 'ShowClaimsList.php';
      $content = ShowClaimsList();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Жалобы</title>', $html);
      break;
   case 41:  // отображение конкретной жалобы
      require 'ShowClaim.php';
      $content = ShowClaim();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Жалоба</title>', $html);
      break; 
   case 42:  // страница About
      require 'ShowAbout.php';
      $content = ShowAbout();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - О форуме</title>', $html);
      break;
   case 50:   // публичная страница участника с id
      require 'ShowUserInfo.php';
      $id = substr($_GET['id'], 0, 5);
      $content = ShowUserInfo($id);
      if (isset($_SESSION['User_Name'])){ // получаем имя из переменной сессии
         $username = $_SESSION['User_Name'];
         unset($_SESSION['User_Name']);
      }else{
         $username = '';
      }
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - '.$username.'</title>', $html);
      break;
   case 51:   // список всех участников
      require 'ShowUsersList.php';
      $content = ShowUsersList();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Участники</title>', $html);
      break;
   case 52:   // список всех топиков участника
      require 'ShowUserTopics.php';
      $content = ShowUserTopics();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Топики участника</title>', $html);
      break;
   case 53:   // список всех сообщений участника
      require 'ShowUserPosts.php';
      $content = ShowUserPosts();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Сообщения участника</title>', $html);
      break;
   case 54:   // анкета участника
      require 'ShowUserQuest.php';
      $content = ShowUserQuest();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Анкета участника</title>', $html);
      break;
   case 100:    // форма запроса на смену пароля по почте  
      $content = file_get_contents('./templates/NewPassRequestForm.html');
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Смена пароля</title>', $html);
      break;    
   case 101:    // форма для ввода нового пароля
      require 'ShowNewPassForm.php';
      $content = ShowNewPassForm();
      $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Смена пароля</title>', $html);
      break;
   case 200: // любое информационное сообщение, переданное через переменную сессии 'msg'  
      if (isset($_SESSION['msg'])){ //если есть сообщение
         $content = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
         <tr><td><div align="center">'.$_SESSION['msg'].'</div></td></tr><tr><td height="10px"></td></tr></table>';
         $html = str_replace('<title>AGI.place</title>', '<title>AGI.place - Сообщение</title>', $html);
         unset($_SESSION['msg']);
      }    
      break;
   default: // титульная заглавная страница / список топиков
      require 'ShowTopicsList.php';
      $content = ShowTopicsList();
   }

if ($islogged){ //устанавливаем отображение меню здесь, поскольку после прочтения сообщений количество новых уменьшается
   $stmt = mysqli_prepare($DB, 'SELECT id_pm FROM pm WHERE id_to=? AND isread=0 AND isdelete_to=0'); //подсчитываем сколько новых личных сообщений нам пришло
   mysqli_stmt_bind_param($stmt, 'i', $_COOKIE['iduser']);
   mysqli_stmt_execute($stmt);
   mysqli_stmt_store_result($stmt);
   $num1 = mysqli_stmt_num_rows($stmt);
   mysqli_stmt_close($stmt);
   if ($num1 > 0){
      $menu = str_replace('{newincom}', ' '."$num1", $menu);
      $menu = str_replace('{newtotal}', '('."$num1".')', $menu);
   }else{
      $menu = str_replace('{newincom}', '', $menu);
      $menu = str_replace('{newtotal}', '', $menu);
   }   
   ///здесь может быть подсчёт количества удалённого с форума нашего контента для отображения в меню
}

if ($status == 'create'){ //отображение количества непроголосованных жалоб
   $stmt = mysqli_prepare($DB, 'SELECT id_claim FROM claims WHERE status="vote" AND id_claim NOT IN (SELECT id_claim FROM votes WHERE id_from=?)'); 
   mysqli_stmt_bind_param($stmt, 'i', $_COOKIE['iduser']);
   mysqli_stmt_execute($stmt);
   mysqli_stmt_store_result($stmt);
   $num = mysqli_stmt_num_rows($stmt);
   mysqli_stmt_close($stmt);
   if ($num > 0){
      $menu = str_replace('{newclaims}', "$num", $menu);
      $html = str_replace('{newclaims}', '('."$num".')', $html);
   }else{
      $menu = str_replace('{newclaims}', '', $menu);
      $html = str_replace('{newclaims}', '', $html);
   }
}else{ //количество жалоб отображаем только тем, кто может за них голосовать
   $menu = str_replace('{newclaims}', '', $menu);
   $html = str_replace('{newclaims}', '', $html);
}

mysqli_close($DB);
setcookie('lastvisit', date('Y-m-d H:i:s'), 2147483647,'/','',true,true);
$html = str_replace('{menu}', $menu, $html);
$html = str_replace('{content}', $content, $html);
echo $html;
} 
?>